/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.viewlets.internal.comments.FullCommentDetails");

dojo.require("rmps.app.core.util");
dojo.require("rmps.ui.commenting.CommentDetails");
dojo.require("rmps.ui.resource.ResourceIconLabel");

dojo.declare("rmps.viewlets.internal.comments.FullCommentDetails", rmps.ui.commenting.CommentDetails, {

	bodyLength: -1,

	// private properties
	_resourceIconLabel: null,

	postCreate: function() {
		this.inherited(arguments);
		this._resourceIconLabel = new rmps.ui.resource.ResourceIconLabel({
			isLink: true,
			showLongName: true,
			linkHref: this.getProjectPrefix()+ rmps.app.core.util.getDesignViewResourceUri(this.comment.resourceUri) + "&comment=" + encodeURIComponent(this.comment.uri)
		});
		this.domNode.insertBefore(this._resourceIconLabel.domNode, this.domNode.firstChild);

		this.comment.getResourceInfo(['shortName', 'iconUri', 'longName']).addCallback(this, function(resourceInfo) {
			this._resourceIconLabel.setResourceInfo(resourceInfo);
		});
	},

	startup: function() {
		this._resourceIconLabel.startup();
		this.inherited(arguments);
	},

	destroy: function() {
		this._resourceIconLabel.destroyRecursive();
		this.inherited(arguments);
	}
});

})();