/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.viewlets.internal.resource.ListPresentation");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("rmps.app.core.util");
dojo.require("rmps.ui.resource.ResourceIconLabel");

var CoreUtil = rmps.app.core.util;

dojo.declare("rmps.viewlets.internal.resource.ListPresentation", [dijit._Widget, dijit._Templated], {

	templateString: '<div class="rmps-viewlets-resource-popularity-list"></div>',

	// mixin properties
	results: null,
	contextURI: null,
	useJazzResourceLinks: false,

	postCreate: function() {
		this.containerNode = this.domNode;
		
		var url = this.getProjectPrefix();
		var query = {};
		if (dojo.config.isDebug) {
			query["debug"] = true;
		}
		if (this.contextURI) {
			query["rmps.context"] = this.contextURI;			
		}
		var querystr = dojo.objectToQuery(query);
		if (querystr) {
			url += '?' + querystr;
		}
	
		for (var i = 0; i < this.results.length; ++i) {
			var listItem = dojo.doc.createElement("div");
			var resIL = new rmps.ui.resource.ResourceIconLabel({
				resourceInfo: this.results[i].info,
				isLink: true,
				linkHref: url + CoreUtil.getDesignViewResourceUri(this.results[i].info.uri),
				hasJazzResourceLink: this.useJazzResourceLinks
			});

			listItem.appendChild(resIL.domNode);

			var frequency = dojo.doc.createElement("span");
			frequency.className = "frequency";
			frequency.appendChild(dojo.doc.createTextNode("(" + this.results[i].value + ")"));
			listItem.appendChild(frequency);

			this.domNode.appendChild(listItem);

			resIL.startup();
		}
	}

});

})();