
/*
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
if (typeof window.__ckeditor_def__ === "undefined") {
    window.__ckeditor_def__ = false;
}

(function(){
    dojo.provide("rmpw.text.internal.widgets.CKEditorFactory");
	dojo.require("rmpw.text.internal.plugins.DMCKEditorPlugins");
   
   // CKEditor Configuration objects...
    rmpw.text.internal.widgets.CKEditorFactory.EditorTypes = {};
    rmpw.text.internal.widgets.CKEditorFactory.UseSource = false;
    
    var styleRegex = new RegExp( '<style>(.*)<\\/style>', 'ig' );
    
    
    // Summary:
    //		This function will check to see if the CKEDITOR global object exists,
    //      normally it will not, so it then injects the relevant script tag using
    //		the DOM API.  This technique will cause the browser to load the ckeditor 
    //      script asynchronously, so the editor is not ready to be used in until we
    //      know that this script has been loadedso the function connects to the script
    //		tags onload method (onreadystatechange for IE) to learn when that is
    //
    //      The "factory" exposes a single function called create().
    //
    //      sample usage would be :
    //		dojo.require("com.ibm.rdm.web.editor.CKEditorFactory");
    //		...
    //		...
    //		var nodeToReplaceWithEditor = dojo.byId("foo"),
    //			types = com.ibm.rdm.web.editor.CKEditorFactory.EditorTypes,
    //			onCreate = dojo.hitch(this, function (ckeditorInstance) {
    //				this.localCKEditorReference = ckeditorInstance;
    //			});
    //
    //		com.ibm.rdm.web.editor.CKEditorFactory.create(nodeToReplaceWithEditor, types.COMMENT_EDITOR, onCreate);
    //			
    
    // This object can contain the configuration we probably want
    // across all uses of the CKEditor within RM Web.
    var RDM_BASE_CONFIG = {
        // remove HTML doc structure breadcrumb and lotus plugins
        // do NOT remove customdialogs plugin, this plugin makes some modifications to table dialogs
        // to support bidi and to support accessible color selection for table cells
        //      removePlugins: "elementspath,sametimeemoticons,lotustoolbars,urllink,lotusstatusmessage,lotusbidi,doclink", 
		removePlugins: 'elementspath, resize, autogrow, lotuspasteiframe',
        coreStyles_bold: {
            element: "b" // use a <b> instead of a <strong>
        },
        coreStyles_italic: {
            element: "i" // use an <i> instead of an <em>
        },
        coreStyles_strike: {
            element: "del"
        },
		skin: "rational",
        language: djConfig.locale, // for FF
        enableTabKeyTools: true,
        menu_groups: "clipboard,tablecell,tablecellproperties,tablerow,tablecolumn,table,insert,glossary,customlink,openresource,diagram,externalIntegration,edit",
        fontSize_sizes: "8/8pt;9/9pt;10/10pt;11/11pt;12/12pt;14/14pt;16/16pt;18/18pt;20/20pt;22/22pt;24/24pt;26/26pt;28/28pt;36/36pt;48/48pt;72/72pt",
        font_defaultLabel: "Arial",
        fontSize_defaultLabel: "10"
    
    
    };
    
    
    // Toolbar array specifies list of required commands.
    var commentToolbarItems = ['Source', '-', 'Font', 'FontSize', '-', 'Bold', 'Italic', 'Underline', 'Strike', '-', 'TextColor', 'BGColor', '-', 'RemoveFormat', '-', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'Outdent', 'Indent', '-', 'BulletedList', 'NumberedList', 'Table', 'Paste', 'PasteText', '-', 'CustomLink', 'Unlink'];


    if (!djConfig.isDebug) {
        commentToolbarItems.splice(0, 2);
    }

    rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.COMMENT_EDITOR = dojo.delegate(RDM_BASE_CONFIG, {
		toolbar: [commentToolbarItems],
//        extraPlugins: "liststyle", //"customops,customLink",
        toolbarCanCollapse: false
    
    });
    
    //TODO: Look at standard toolbars and plugins defined by the Lotus OneUI teams!
    
    var toolbarItems = [['Source', '-', 'Format', 'Font', 'FontSize', '-', 'Bold', 'Italic', 'Underline', 'Strike', 'Subscript', 'Superscript', '-', 'Cut', 'Copy', 'Paste', 'PasteText', '-', 'Find']];
	// Ttoolbar won't wrap in Safarari and Chrome, work-around: add a new line for those
	// (another workaround would be to remove "nowrap" style from .cke_skin_rational * in editor.css)
	var is_safari = navigator.userAgent.toLowerCase().indexOf('safari/') > -1;	// (detects both Safari and Chrome)
	if (is_safari) {
		toolbarItems.push('/');
	};
	toolbarItems.push(['TextColor', 'BGColor', '-', 'RemoveFormat', '-', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'Outdent', 'Indent', '-', 'BulletedList', 'NumberedList', 'Table', '-', 'InsertDiagram', 'Image', '-', 'CustomLink', 'Unlink']);
   
    var slimToolbarItems = [['Source', '-', 'Font', 'FontSize', '-', 'Bold', 'Italic', 'Underline', '-', 'Cut', 'Copy', 'Paste', '-', 'BulletedList', 'NumberedList', '-', 'CustomLink', 'Unlink']];
    
    

    if (!djConfig.isDebug) {
        toolbarItems[0].splice(0, 2);
        slimToolbarItems[0].splice(0, 2);
    }

    var extraPlugins = "liststyle,insertimage,customops,customLink,insertdiagram,externalIntegration,insertartifact,markAsRequirement,markAndEmbedRequirement,lookupGlossaryTerm,createTerm,createTraceLink,dndUpload,followLink,openresource,lotustabletools,resize,preview";
    
    
    rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.RICH_TEXT_ARTIFACT_EDITOR = dojo.delegate(rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.COMMENT_EDITOR, {
        toolbar: toolbarItems,
        format_tags: 'p;h1;h2;h3;h4'
		,
        extraPlugins: 'customLink,insertdiagram,openresource' 
    });
    
    rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.RICH_TEXT_SLIM_EDITOR = dojo.delegate(rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.COMMENT_EDITOR, {
        toolbar: slimToolbarItems,
        format_tags: 'p;h1;h2;h3;h4'
		,
        extraPlugins: 'customLink,insertdiagram,openresource' 
    });
    
    rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.RICH_TEXT_NO_TOOLBAR_EDITOR = dojo.delegate(rmpw.text.internal.widgets.CKEditorFactory.EditorTypes.COMMENT_EDITOR, {
        toolbar: [[]],
        format_tags: 'p;h1;h2;h3;h4'
		,
        extraPlugins: 'customLink,insertdiagram,openresource' 
    });
    
    
    
    
    // We need to tell CK Editor where it is installed.
    // By default, CKEditor looks for the "ckeditor.js" file in the <script> tags
    // present in the page to automatically retrieve its installation path
    window.CKEDITOR_BASEPATH = net.jazz.ajax._contextRoot + "/web/rmpw.ckeditor/internal/ckeditor/";
    var CKEDITOR_SCRIPT_SRC = net.jazz.ajax._contextRoot + "/web/rmpw.ckeditor/internal/ckeditor/ckeditor.js", loadedCon, loadedCKEditor = function(){
        
        // This was causing some errors in IE, it seems to stem from the fact
        // that the CKEditor is no longer in the DOM at the point the blur()
        // is happening, here we just decorate the original function with a
        // simple check.
        if (dojo.isIE) {
            var forceBlur = CKEDITOR.focusManager.prototype.forceBlur;
            CKEDITOR.focusManager.prototype.forceBlur = function(){
                if (this.hasFocus) {
                    var editor = this._.editor;
                    if (editor.container.getChild(1)) {
                        try {
                            forceBlur.apply(this);
                        } 
                        catch (E) {
                            console.debug("Error ", E);
                        }
                    }
                }
                
            };
            
            // CSS issues with IE due to 31 style sheet limit
            CKEDITOR.document.appendStyleSheet = function(cssFileUrl) {
                var styleURL = cssFileUrl,
                    styleSheet, i, parent, cssRules;
                 
                //TODO delete this step when WI 39263 is resolved   
                //remove all the stylesheets without any rules
                for(i = document.styleSheets.length - 1; i >= 0; i--){
                    cssRules = document.styleSheets[i].cssRules || document.styleSheets[i].rules;
                    if(cssRules.length === 0){
                        styleSheet = document.styleSheets[i].ownerNode || document.styleSheets[i].owningElement;
                        parent = styleSheet.parentNode;
                        parent.removeChild(styleSheet);
                    }
                }
                  
                //if there's still more than 30, import into an already existing CSS (copied from jazz.core.loader#addCSS)              				
				if (dojo.isIE <= 9 && document.styleSheets.length > 30) {
				    console.debug("CKEditorFactory: appendStyleSheet avoided IE CSS limitation");
					for (i = 0; i < document.styleSheets.length; i++) {
						if (document.styleSheets[i].imports.length < 31) {
							styleSheet = document.styleSheets[i];
							break;
						}
					}
					if (styleSheet !== null) {
						styleSheet.addImport(styleURL);	
					} else {
						throw new Error("No stylesheet is available to add an import to");
					}
				} else {
					var link = new CKEDITOR.dom.element('link');
					link.setAttributes({
						rel		:'stylesheet',
						type	: 'text/css',
						href	: cssFileUrl
					});
					this.getHead().append(link);
				}
            };
			var setHtmlOrig = CKEDITOR.dom.element.prototype.setHtml;
			dojo.extend(CKEDITOR.dom.element, {
				setHtml: function(html) {
					// Make sure <style> tags are handled separately
					var parts;
					while ((parts = styleRegex.exec(html))) {
						var stylepart = parts[1];
						if (stylepart) {
							if (dojo.isIE <= 9 && document.styleSheets.length > 30) {
								console.debug("CKEditorFactory: setHtml avoided IE CSS limitation");
								var styleSheet;
								for (var i = 0; i < document.styleSheets.length; i++) {
									// The rule limit per style sheet is 4095. Find a style sheet with a lot of room.
									if (document.styleSheets[i].rules.length < 2000) {
										styleSheet = document.styleSheets[i];
										break;
									}
								}
								if (styleSheet !== null) {
									styleSheet.cssText += stylepart;
								} else {
									throw new Error("No stylesheet is available to add rules to");
								}
							} else {
								var styleSheet = document.createStyleSheet("");
								styleSheet.cssText = stylepart;
							}
						}
						html = html.substring(0, parts.index) + html.substring(styleRegex.lastIndex);
					}
					setHtmlOrig.apply(this, arguments);
				}
			});
        }
        rmpw.text.internal.plugins.DMCKEditorPlugins.defineDMPlugins();

        dojo.disconnect(loadedCon);
    }, replaceNode = function(node, options){
        return CKEDITOR.replace(node, options);
    }, appendToNode = function(node, options){
        return CKEDITOR.appendTo(node, options);
    };
    
    if (typeof CKEDITOR === "undefined") {
			var onLoad = function(data){
                 if (!window.__ckeditor_def__) {
                     dojo.eval(data);
                 }
             };
        rmpw.text.internal.widgets.CKEditorFactory.UseSource = dojo.queryToObject(location.search.substr(1, location.search.length)).fullcke;
        if (rmpw.text.internal.widgets.CKEditorFactory.UseSource) {
             var scripts = [//
             net.jazz.ajax._contextRoot + "/web/rmpw.ckeditor/internal/ckeditor/_source/core/ckeditor_base.js",
			 net.jazz.ajax._contextRoot + "/web/rmpw.ckeditor/internal/ckeditor/_source/core/loader.js",
			 ];
             for (var i = 0, len = scripts.length; i < len; ++i) {
                 // load the script...
                 dojo.xhrGet({
                     url: scripts[i],
                     sync: true,
                     handleAs: "text",
                     load: onLoad,
                     error: alert
                 });
             }
			 CKEDITOR.basePath = net.jazz.ajax._contextRoot + "/web/rmpw.ckeditor/internal/ckeditor/";
             CKEDITOR.loader.load("core/ckeditor");
	 } else {
			// load the script...
            dojo.xhrGet({
                url: CKEDITOR_SCRIPT_SRC,
                sync: true,
                handleAs: "text",
                load: onLoad,
                error: alert
            });
		}
        loadedCKEditor();
        window.__ckeditor_def__ = true;
    }
	
    rmpw.text.internal.widgets.CKEditorFactory.create = function(/*Element*/node, /*CKEDITOR.configuration*/ options, /*Function*/ callback, /*Boolean?*/ append){
        // Summary:
        //  Create a CKEDITOR instance and replace the argument "node" 
        //  clients are asked to provide a callback just incase the async. script
        //  loading hasn't completed.  Usually it will have since this object should
        //  be dojo.require()'d in bootstrap.js
        if (typeof CKEDITOR === "undefined") {
            var con = dojo.connect(this, loadedCKEditor, function(){
                dojo.disconnect(con);
                var cb = null;
                if (!append) {
                    cb = replaceNode(node, options);
                }
                else {
                    cb = appendToNode(node, options);
                }
                if (callback) {
                    callback(cb);
                }
            });
        }
        else {
			var cb = null;
            if (!append) {
                 cb = replaceNode(node, options);
            }
            else {
                cb = appendToNode(node, options);
            }
            if (callback) {
                callback(cb);
            }
        }
    };
	
	

    
})();
