/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.filters.BooleanFilterWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("rmps.ui.queryeditor.filters.IValueFilter");

dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.filters.BooleanFilterWidget", [dijit._Widget, dijit._Templated, rmps.ui.queryeditor.filters.IValueFilter], {
	templatePath: dojo.moduleUrl("rmps.ui", "queryeditor/filters/templates/BooleanFilterWidget.html"),

	_inputName: messages.labelBooleanFilter,
	_label: messages.labelBooleanFilter,
	
	getValue: function() {
		return !!this._inputNode.checked;
	},
	
	getDataType: function() {
		return QueryConstants.BOOLEAN_DATATYPE;
	},
	
	getSign: function() {
		return QueryConstants.PREDICATE_VALUE_CONDITION_SIGN_EQUAL;	
	},
	
	setValue: function(value) {
		this._inputNode.checked = value; 
	},
	
	setSign: function(sign) {
	},
	
	validate: function(valResult) {
	},
	
	_onValueChange: function(e) {
		if (this.changeCallback) {
			this.changeCallback();
		}
	}
});

})();