/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
	
	dojo.provide("rmps.app.ui.internal.pages.DMProjectDashboardPage");
	
	dojo.require("com.ibm.team.dashboard.web.ui.ProjectDashboardPage");
	dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
	dojo.require("rmps.core.util.ContextUtils");
	
	var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
	var ContextUtils = rmps.core.util.ContextUtils;
	
	var addBaselineParamToURL = function(url) {
		var context = ContextUtils.computeContextParams();
		if (context) {
			var parts = url.split("#");
			var add = (parts[0] && parts[0].indexOf("?") === -1) ? "?" : "&"; 
			parts[0] += add + context;
			url = parts.join("#");			
		}
		return url;
	};
	
	dojo.declare("rmps.app.ui.internal.pages.DMProjectDashboardPage", com.ibm.team.dashboard.web.ui.ProjectDashboardPage, {
		
		showProjectDashboard: function(page) {
			this.inherited(arguments);
				
			// Look for the breadcrumb corresponding to AllDashboardPages	
			var breadcrumbs = this.breadcrumbs;
			var segments = breadcrumbs.segments;
			if (segments && dojo.isArray(segments)) {
				for (var i = 0; i < segments.length; i++) {
					var segment = segments[i];
					var allDashboardsAction = segment.href.indexOf(DashboardConstants.ACTION_VIEW_ALL_DASHBOARDS) > 0;
					var noContextDefined = segment.href.indexOf(ContextUtils.CONTEXT_PARAM) < 0;
					if (allDashboardsAction && noContextDefined) {
						var allDashboardsUrl = segment.href;
						segment.href = addBaselineParamToURL(allDashboardsUrl);
						breadcrumbs.refresh();
					}	
				}
			}
		}

	}); // end of declare
	
	
}()); // end of function